From 4930a61fbeee2560261e9e897e9e51200b147ff1 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Sun, 4 Feb 2024 16:31:30 +0200
Subject: [PATCH 25/25] amplio2/cimpletoon: Add Nets

Graphics by Elefant

See RM #224

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/amplio2.tilespec      |   1 +
 data/amplio2/terrain1.png  | Bin 271080 -> 298082 bytes
 data/amplio2/terrain1.spec |   1 +
 data/cimpletoon.tilespec   |   1 +
 4 files changed, 3 insertions(+)

diff --git a/data/amplio2.tilespec b/data/amplio2.tilespec
index 102f5eddd8..2110944858 100644
--- a/data/amplio2.tilespec
+++ b/data/amplio2.tilespec
@@ -342,6 +342,7 @@ styles =
       "tx.mine",       "Single1"
       "tx.oil_mine",   "Single1"
       "tx.oil_rig",    "Single1"
+      "tx.nets",       "Single1"
       "tx.pollution",  "Single2"
       "tx.fallout",    "Single2"
       "tx.village",    "Single1"
diff --git a/data/amplio2/terrain1.png b/data/amplio2/terrain1.png
index 2b18d51afefd1f2803b1fd7b5b8b82350d39a36c..2ec7783cb2736bbdbe674fb9e4b98ded641d48fa 100644
GIT binary patch
diff --git a/data/amplio2/terrain1.spec b/data/amplio2/terrain1.spec
index 8ed3e553c1..a9fd11e599 100644
--- a/data/amplio2/terrain1.spec
+++ b/data/amplio2/terrain1.spec
@@ -122,6 +122,7 @@ tiles = { "row", "column", "tag"
  5,  6, "tx.village"
  6,  6, "tx.fallout"
  7,  6, "tx.oil_rig"
+ 8,  6, "tx.nets"
 
  15,  0, "t.dither_tile"
  15,  0, "tx.darkness"
diff --git a/data/cimpletoon.tilespec b/data/cimpletoon.tilespec
index 4f93d065b8..68404e6b49 100644
--- a/data/cimpletoon.tilespec
+++ b/data/cimpletoon.tilespec
@@ -366,6 +366,7 @@ styles =
       "tx.mine",       "Single1"
       "tx.oil_mine",   "Single1"
       "tx.oil_rig",    "Single1"
+      "tx.nets",       "Single1"
       "tx.pollution",  "Single2"
       "tx.fallout",    "Single2"
       "tx.village",    "Single1"
-- 
2.43.0