From 29030703018dc22f6bdda4395568999ffe25bc2e Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Wed, 7 Feb 2024 22:16:01 +0200
Subject: [PATCH 39/39] Clear trailing spaces from fcmp code

See RM #238

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 tools/fcmp/download.c   | 8 ++++----
 tools/fcmp/mpcmdline.h  | 2 +-
 tools/fcmp/mpgui_gtk3.c | 6 +++---
 tools/fcmp/mpgui_gtk4.c | 4 ++--
 tools/fcmp/mpgui_gtk5.c | 4 ++--
 5 files changed, 12 insertions(+), 12 deletions(-)

diff --git a/tools/fcmp/download.c b/tools/fcmp/download.c
index cc1e13a95a..7d58887b3b 100644
--- a/tools/fcmp/download.c
+++ b/tools/fcmp/download.c
@@ -153,7 +153,7 @@ static const char *download_modpack_recursive(const char *URL,
 
     secfile_destroy(control);
 
-    return _("Modpack control file is incompatible");  
+    return _("Modpack control file is incompatible");
   }
 
   mpname = secfile_lookup_str(control, "info.name");
@@ -246,7 +246,7 @@ static const char *download_modpack_recursive(const char *URL,
     }
 
     dep++;
-    
+
   } while (dep_name != NULL);
 
 
@@ -464,7 +464,7 @@ const char *download_modpack_list(const struct fcmp_params *fcmp,
 
     secfile_destroy(list_file);
 
-    return _("Modpack list is incompatible");  
+    return _("Modpack list is incompatible");
   }
 
   msg = secfile_lookup_str_default(list_file, NULL, "info.message");
@@ -525,7 +525,7 @@ const char *download_modpack_list(const struct fcmp_params *fcmp,
       } else {
         sz_strlcpy(mpURL_full, mpURL);
       }
-      
+
       cb(mp_name, mpURL_full, mpver, mplic, type, _(mp_subtype), mp_notes);
     }
     modpack_count++;
diff --git a/tools/fcmp/mpcmdline.h b/tools/fcmp/mpcmdline.h
index 0d27fcc528..76f2064e72 100644
--- a/tools/fcmp/mpcmdline.h
+++ b/tools/fcmp/mpcmdline.h
@@ -1,4 +1,4 @@
-/********************************************************************** 
+/***********************************************************************
  Freeciv - Copyright (C) 1996 - A Kjeldberg, L Gregersen, P Unold
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
diff --git a/tools/fcmp/mpgui_gtk3.c b/tools/fcmp/mpgui_gtk3.c
index 557631a2b0..db9f8e031b 100644
--- a/tools/fcmp/mpgui_gtk3.c
+++ b/tools/fcmp/mpgui_gtk3.c
@@ -56,7 +56,7 @@ static gboolean quit_dialog_callback(void);
 #define ML_COL_INST    2
 #define ML_COL_TYPE    3
 #define ML_COL_SUBTYPE 4
-#define ML_COL_LIC     5 
+#define ML_COL_LIC     5
 #define ML_COL_URL     6
 
 #define ML_COL_COUNT   7
@@ -103,7 +103,7 @@ static gboolean quit_dialog_callback(void)
 
       gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_MOUSE);
 
-      g_signal_connect(dialog, "response", 
+      g_signal_connect(dialog, "response",
                        G_CALLBACK(quit_dialog_response), NULL);
       g_signal_connect(dialog, "destroy",
                        G_CALLBACK(gtk_widget_destroyed), &dialog);
@@ -456,7 +456,7 @@ static void modinst_setup_widgets(GtkWidget *toplevel)
   main_list = gtk_tree_view_new();
   renderer = gtk_cell_renderer_text_new();
   gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(main_list),
-                                              ML_COL_NAME,      
+                                              ML_COL_NAME,
                                               _("Name"), renderer, "text", 0,
                                               NULL);
   renderer = gtk_cell_renderer_text_new();
diff --git a/tools/fcmp/mpgui_gtk4.c b/tools/fcmp/mpgui_gtk4.c
index ca27941390..a50d028b6f 100644
--- a/tools/fcmp/mpgui_gtk4.c
+++ b/tools/fcmp/mpgui_gtk4.c
@@ -60,7 +60,7 @@ static gboolean quit_dialog_callback(void);
 #define ML_COL_INST    2
 #define ML_COL_TYPE    3
 #define ML_COL_SUBTYPE 4
-#define ML_COL_LIC     5 
+#define ML_COL_LIC     5
 #define ML_COL_URL     6
 
 #define ML_COL_COUNT   7
@@ -472,7 +472,7 @@ static void modinst_setup_widgets(void)
   main_list = gtk_tree_view_new();
   renderer = gtk_cell_renderer_text_new();
   gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(main_list),
-                                              ML_COL_NAME,      
+                                              ML_COL_NAME,
                                               _("Name"), renderer, "text", 0,
                                               NULL);
   renderer = gtk_cell_renderer_text_new();
diff --git a/tools/fcmp/mpgui_gtk5.c b/tools/fcmp/mpgui_gtk5.c
index 42fadaa0ce..3a4587b4a4 100644
--- a/tools/fcmp/mpgui_gtk5.c
+++ b/tools/fcmp/mpgui_gtk5.c
@@ -60,7 +60,7 @@ static gboolean quit_dialog_callback(void);
 #define ML_COL_INST    2
 #define ML_COL_TYPE    3
 #define ML_COL_SUBTYPE 4
-#define ML_COL_LIC     5 
+#define ML_COL_LIC     5
 #define ML_COL_URL     6
 
 #define ML_COL_COUNT   7
@@ -464,7 +464,7 @@ static void modinst_setup_widgets(void)
   main_list = gtk_tree_view_new();
   renderer = gtk_cell_renderer_text_new();
   gtk_tree_view_insert_column_with_attributes(GTK_TREE_VIEW(main_list),
-                                              ML_COL_NAME,      
+                                              ML_COL_NAME,
                                               _("Name"), renderer, "text", 0,
                                               nullptr);
   renderer = gtk_cell_renderer_text_new();
-- 
2.43.0