From 255a51659d522cc89bdef98c1d32140376bc0170 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Sun, 11 Feb 2024 21:53:18 +0200
Subject: [PATCH 42/42] Add Dagestan nation

Ruleset by _Rorr404, with minor adjustment by me

See RM #254

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/default/nationlist.ruleset      |   1 +
 data/flags/Makefile.am               |   5 ++
 data/flags/dagestan-large.png        | Bin 0 -> 299 bytes
 data/flags/dagestan-shield-large.png | Bin 0 -> 274 bytes
 data/flags/dagestan-shield.png       | Bin 0 -> 249 bytes
 data/flags/dagestan.png              | Bin 0 -> 277 bytes
 data/flags/dagestan.svg              |   6 +++
 data/misc/flags-large.spec           |   1 +
 data/misc/flags.spec                 |   2 +
 data/misc/shields-large.spec         |   1 +
 data/misc/shields.spec               |   1 +
 data/nation/Makefile.am              |   1 +
 data/nation/dagestan.ruleset         |  76 +++++++++++++++++++++++++++
 data/nation/russian.ruleset          |   2 +-
 data/nation/soviet.ruleset           |   3 +-
 meson.build                          |   2 +
 16 files changed, 99 insertions(+), 2 deletions(-)
 create mode 100644 data/flags/dagestan-large.png
 create mode 100644 data/flags/dagestan-shield-large.png
 create mode 100644 data/flags/dagestan-shield.png
 create mode 100644 data/flags/dagestan.png
 create mode 100644 data/flags/dagestan.svg
 create mode 100644 data/nation/dagestan.ruleset

diff --git a/data/default/nationlist.ruleset b/data/default/nationlist.ruleset
index decb9ce193..c835d3c75b 100644
--- a/data/default/nationlist.ruleset
+++ b/data/default/nationlist.ruleset
@@ -262,6 +262,7 @@ default_nationset = "all"
 *include "nation/czech.ruleset"
 *include "nation/czechoslovak.ruleset"
 *include "nation/dacian.ruleset"
+*include "nation/dagestan.ruleset"
 *include "nation/dahomean.ruleset"
 *include "nation/danish.ruleset"
 *include "nation/darfuri.ruleset"
diff --git a/data/flags/Makefile.am b/data/flags/Makefile.am
index 512a87d517..66953c974b 100644
--- a/data/flags/Makefile.am
+++ b/data/flags/Makefile.am
@@ -137,6 +137,7 @@ flag_files =				\
 		czech.png		\
 		czechoslovakia.png	\
 		dacian.png		\
+		dagestan.png		\
 		dahomey.png		\
 		darfur.png		\
 		ddr.png			\
@@ -709,6 +710,7 @@ flag_files =				\
 		czech-large.png		\
 		czechoslovakia-large.png	\
 		dacian-large.png		\
+		dagestan-large.png		\
 		dahomey-large.png		\
 		darfur-large.png		\
 		ddr-large.png			\
@@ -1283,6 +1285,7 @@ shield_files =					\
 		czech-shield.png		\
 		czechoslovakia-shield.png	\
 		dacian-shield.png		\
+		dagestan-shield.png		\
 		dahomey-shield.png		\
 		darfur-shield.png		\
 		ddr-shield.png			\
@@ -1855,6 +1858,7 @@ shield_files =					\
 		czech-shield-large.png		\
 		czechoslovakia-shield-large.png		\
 		dacian-shield-large.png			\
+		dagestan-shield-large.png		\
 		dahomey-shield-large.png		\
 		darfur-shield-large.png			\
 		ddr-shield-large.png			\
@@ -2429,6 +2433,7 @@ svg_files = 				\
 		czech.svg		\
 		czechoslovakia.svg	\
 		dacian.svg		\
+		dagestan.svg		\
 		dahomey.svg		\
 		darfur.svg		\
 		ddr.svg			\
diff --git a/data/flags/dagestan-large.png b/data/flags/dagestan-large.png
new file mode 100644
index 0000000000000000000000000000000000000000..48aeb05cd16a70b42f02adf46fa1d4ef05024694
GIT binary patch
diff --git a/data/flags/dagestan-shield-large.png b/data/flags/dagestan-shield-large.png
new file mode 100644
index 0000000000000000000000000000000000000000..c61ff19b5ee8fd6aae2f34fd2b2a7997fb89c3a3
GIT binary patch
diff --git a/data/flags/dagestan-shield.png b/data/flags/dagestan-shield.png
new file mode 100644
index 0000000000000000000000000000000000000000..1334bd08551f9eb834bc2f86b14b93e6bfab51ec
GIT binary patch
diff --git a/data/flags/dagestan.png b/data/flags/dagestan.png
new file mode 100644
index 0000000000000000000000000000000000000000..7b063fe10812fd213aadb75a5a880078b72edb97
GIT binary patch
diff --git a/data/flags/dagestan.svg b/data/flags/dagestan.svg
new file mode 100644
index 0000000000..05ebb55b13
--- /dev/null
+++ b/data/flags/dagestan.svg
@@ -0,0 +1,6 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<svg xmlns="http://www.w3.org/2000/svg" width="900" height="600" viewBox="0 0 9 6">
+<rect fill="#D81E05" width="9" height="6"/>
+<rect fill="#0039a6" width="9" height="4"/>
+<rect fill="#00923F" width="9" height="2"/>
+</svg>
\ No newline at end of file
diff --git a/data/misc/flags-large.spec b/data/misc/flags-large.spec
index 21dfd31c29..dd53a405d0 100644
--- a/data/misc/flags-large.spec
+++ b/data/misc/flags-large.spec
@@ -146,6 +146,7 @@ sprites =
 		"f.czech", "flags/czech-large"
 		"f.czechoslovakia", "flags/czechoslovakia-large"
 		"f.dacian", "flags/dacian-large"
+		"f.dagestan", "flags/dagestan-large"
 		"f.dahomey", "flags/dahomey-large"
 		"f.darfur", "flags/darfur-large"
 		"f.ddr", "flags/ddr-large"
diff --git a/data/misc/flags.spec b/data/misc/flags.spec
index ab27dc1ae7..3096913a50 100644
--- a/data/misc/flags.spec
+++ b/data/misc/flags.spec
@@ -144,6 +144,7 @@ artists = "
    Czech		Lauris Kaplinski
    Czechoslovakia	Tlusťa (Wikimedia Commons)
    Dacian		Andrzej M. Gorzym
+   Dagestan             Wikimedia Commons
    Dahomey		Daniel Markstedt
    Darfur		Daniel Markstedt
    DDR			Jwnabd (Wikimedia Commons)
@@ -720,6 +721,7 @@ sprites =
 		"f.czech", "flags/czech"
 		"f.czechoslovakia", "flags/czechoslovakia"
 		"f.dacian", "flags/dacian"
+		"f.dagestan", "flags/dagestan"
 		"f.dahomey", "flags/dahomey"
 		"f.darfur", "flags/darfur"
 		"f.ddr", "flags/ddr"
diff --git a/data/misc/shields-large.spec b/data/misc/shields-large.spec
index 9305364291..5c0168e545 100644
--- a/data/misc/shields-large.spec
+++ b/data/misc/shields-large.spec
@@ -146,6 +146,7 @@ sprites =
 		"f.shield.czech", "flags/czech-shield-large"
 		"f.shield.czechoslovakia", "flags/czechoslovakia-shield-large"
 		"f.shield.dacian", "flags/dacian-shield-large"
+		"f.shield.dagestan", "flags/dagestan-shield-large"
 		"f.shield.dahomey", "flags/dahomey-shield-large"
 		"f.shield.darfur", "flags/darfur-shield-large"
 		"f.shield.ddr", "flags/ddr-shield-large"
diff --git a/data/misc/shields.spec b/data/misc/shields.spec
index ebe1938cff..0353509f10 100644
--- a/data/misc/shields.spec
+++ b/data/misc/shields.spec
@@ -145,6 +145,7 @@ sprites =
 		"f.shield.czech", "flags/czech-shield"
 		"f.shield.czechoslovakia", "flags/czechoslovakia-shield"
 		"f.shield.dacian", "flags/dacian-shield"
+		"f.shield.dagestan", "flags/dagestan-shield"
 		"f.shield.dahomey", "flags/dahomey-shield"
 		"f.shield.darfur", "flags/darfur-shield"
 		"f.shield.ddr", "flags/ddr-shield"
diff --git a/data/nation/Makefile.am b/data/nation/Makefile.am
index 2dc456a4a5..ae30600782 100644
--- a/data/nation/Makefile.am
+++ b/data/nation/Makefile.am
@@ -146,6 +146,7 @@ pkgdata_DATA = \
 		czech.ruleset \
 		czechoslovak.ruleset \
 		dacian.ruleset \
+		dagestan.ruleset \
 		dahomean.ruleset \
 		danish.ruleset \
 		darfuri.ruleset \
diff --git a/data/nation/dagestan.ruleset b/data/nation/dagestan.ruleset
new file mode 100644
index 0000000000..884326014a
--- /dev/null
+++ b/data/nation/dagestan.ruleset
@@ -0,0 +1,76 @@
+[nation_dagestan]
+
+name   = _("Dagestan")
+plural = _("?plural:Dagestani")
+groups = "Asian", "European", "Early Modern"
+
+legend = _("Dagestan is a republic of Russia situated in North Caucausus\
+ along the Caspian sea, it is one of the most ethnically diverse of\
+ Russia's republics, it was one of the first people within the modern\
+ borders of Russia to become Muslims after the Arab conquest of the\
+ region in 643. Dagestan was later raided by the Mongols in 1221.\
+ Dagestan eventually came under the control of Russia in 1813 and\
+ was firmly in the control of Imperial Russia as of 1828.\
+ Due to high taxation and general dissatisfaction with the Russian\
+ government, it rose up multiple times against Russia, once in 1828,\
+ and again in 1917, it eventually became an autonomous republic under\
+ the Soviet Union in 1921.")
+
+leaders = {
+ "name",                        "sex"
+ "Kazi-Mulla",                  "Male"  ; Ghazi Muhammad (1793–1832), first Imam of the Caucasian Imamate
+ "Gamzat-bek",                  "Male"  ; (1789-1834), Second Imam of the Caucasian Imamate
+ "Sheykh Shamil",               "Male"  ; Imam Shamil (1797-1871), Third and final Imam of the Causasian Imamate
+ "Ħamzatazul Rasul Ħamzatil",   "Male"  ; Rasul Gamzatovich Gamzatov (1923-2003) Famous poet from Dagestan.
+ "Sergey Melikov",              "Male"  ; Current Head of the Republic of Dagestan
+ "Tapa Tchermoev",              "Male"  ; (1882-1937), First prime minister of the Mountainous Republic of the Northern Caucasus.
+ "Khavarsultan Khanum",         "Female"; 1st wife of Tapa Tchermoev
+ "Natasha Brailovsky",          "Female"; né Kanelsky, 2nd wife of Tapa Tchermoev
+}
+
+ruler_titles = {
+ "government",      "male_title",      "female_title"
+ "Monarchy",        _("Emir %s"),      _("Emira %s")
+ "Fundamentalism",  _("Imam %s"),      _("Imama %s")
+}
+
+flag = "dagestan"
+flag_alt = "-"
+style = "European"
+
+init_techs = ""
+init_buildings = ""
+init_units = ""
+
+conflicts_with = "karelian" ; flag is too similar
+civilwar_nations = "soviet", "russian", "ossetian", "tatar", "chechen", "circassian"
+
+cities =
+ "Machačkala",         ; Makhachkala
+ "Chasavjurt",         ; Khasavyurt
+ "Derbent",
+ "Kaspijsk",           ; Kaspiysk
+ "Bujnaksk",           ; Buynaksk
+ "Izberbaš",           ; Izberbash
+ "Kizljar",            ; Kizlyar
+ "Kiziljurt",          ; Kizilyurt
+ "Dagestanskije Ogni", ; Dagestanskiye Ogni
+ "Leninkent",
+ "Tarki",
+ "Semender",
+ "Belidži",            ; Belidzhi
+ "Šamchal",            ; Shamkhal
+ "Mamedkala",
+ "Al'burikent",        ; Alburikent
+ "Južno-Suchokumsk",   ; Yuzhno-Sukhokumsk
+ "Sulak",
+ "Novyj Kjachulaj",    ; Novy Kyakhulay
+ "Kjachulaj",          ; Kyakhulay
+ "Manas",
+ "Tjube",              ; Tyube
+ "Dubki",
+ "Šamil'kala",         ; Shamilkala
+ "Bavtugaj",           ; Bavtugay
+ "Novyj Sulak",        ; Novy Sulak
+ "Komsomol'skij",      ; Komsomolsky
+ "Ači-Su"              ; Achisu
diff --git a/data/nation/russian.ruleset b/data/nation/russian.ruleset
index a8950b5ea8..4ac4f48c0b 100644
--- a/data/nation/russian.ruleset
+++ b/data/nation/russian.ruleset
@@ -63,7 +63,7 @@ init_units = ""
 conflicts_with = "slovenian", "slovakian",
 ; Transitional state
  "soviet"
-civilwar_nations = "Soviet", "Siberian", "Tatar", "Cossack"
+civilwar_nations = "Soviet", "Siberian", "Tatar", "Cossack", "Dagestan"
 
 cities =
  "Moskva",
diff --git a/data/nation/soviet.ruleset b/data/nation/soviet.ruleset
index d80f04b485..18e848fb2f 100644
--- a/data/nation/soviet.ruleset
+++ b/data/nation/soviet.ruleset
@@ -43,7 +43,8 @@ conflicts_with = "Russian", "Moldovan", "Kazakh", "Kyrgyz", "Tajik",
 civilwar_nations = "Russian", "Ukrainian", "Belarusian",
  "Lithuanian", "Latvian", "Estonian",
  "Moldovan", "Georgian", "Armenian", "Azeri",
- "Kazakh", "Kyrgyz", "Tajik", "Turkmen", "Uzbek"
+ "Kazakh", "Kyrgyz", "Tajik", "Turkmen", "Uzbek",
+ "Dagestan"
 
 cities =
  "Moskva",
diff --git a/meson.build b/meson.build
index 858e3b67b8..b1e111ac4f 100644
--- a/meson.build
+++ b/meson.build
@@ -1670,6 +1670,7 @@ nations = [
   'czechoslovak',
   'czech',
   'dacian',
+  'dagestan',
   'dahomean',
   'danish',
   'darfuri',
@@ -2447,6 +2448,7 @@ flags = [
   'czech',
   'czechoslovakia',
   'dacian',
+  'dagestan',
   'dahomey',
   'darfur',
   'ddr',
-- 
2.43.0