From 8512fa409f3bccefc42cc06a476009b318edd63c Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Sun, 11 Feb 2024 17:32:28 +0200
Subject: [PATCH 15/22] Add Alaskan nation

Ruleset by _Rorr404, with minor adjustment by me

See RM #237

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/default/nationlist.ruleset    |   1 +
 data/flags/Makefile.am             |   5 ++
 data/flags/alaska-large.png        | Bin 0 -> 494 bytes
 data/flags/alaska-shield-large.png | Bin 0 -> 367 bytes
 data/flags/alaska-shield.png       | Bin 0 -> 315 bytes
 data/flags/alaska.png              | Bin 0 -> 413 bytes
 data/flags/alaska.svg              |   1 +
 data/misc/flags-large.spec         |   1 +
 data/misc/flags.spec               |   2 +
 data/misc/shields-large.spec       |   1 +
 data/misc/shields.spec             |   1 +
 data/nation/Makefile.am            |   1 +
 data/nation/alaskan.ruleset        | 113 +++++++++++++++++++++++++++++
 data/nation/aleut.ruleset          |   2 +-
 meson.build                        |   2 +
 translations/nations/POTFILES.in   |   1 +
 16 files changed, 130 insertions(+), 1 deletion(-)
 create mode 100644 data/flags/alaska-large.png
 create mode 100644 data/flags/alaska-shield-large.png
 create mode 100644 data/flags/alaska-shield.png
 create mode 100644 data/flags/alaska.png
 create mode 100644 data/flags/alaska.svg
 create mode 100644 data/nation/alaskan.ruleset

diff --git a/data/default/nationlist.ruleset b/data/default/nationlist.ruleset
index c347b98f07..decb9ce193 100644
--- a/data/default/nationlist.ruleset
+++ b/data/default/nationlist.ruleset
@@ -135,6 +135,7 @@ default_nationset = "all"
 *include "nation/akwe.ruleset"
 *include "nation/alandalus.ruleset"
 *include "nation/alander.ruleset"
+*include "nation/alaskan.ruleset"
 *include "nation/albanian.ruleset"
 *include "nation/aleut.ruleset"
 *include "nation/algerian.ruleset"
diff --git a/data/flags/Makefile.am b/data/flags/Makefile.am
index d8ec951331..512a87d517 100644
--- a/data/flags/Makefile.am
+++ b/data/flags/Makefile.am
@@ -15,6 +15,7 @@ flag_files =				\
 		ainu.png		\
 		akwe.png		\
 		aland.png		\
+		alaska.png		\
 		albania.png		\
 		aleut.png		\
 		algeria.png		\
@@ -586,6 +587,7 @@ flag_files =				\
 		ainu-large.png		\
 		akwe-large.png		\
 		aland-large.png			\
+		alaska-large.png		\
 		albania-large.png		\
 		aleut-large.png		\
 		algeria-large.png		\
@@ -1159,6 +1161,7 @@ shield_files =					\
 		ainu-shield.png			\
 		akwe-shield.png			\
 		aland-shield.png		\
+		alaska-shield.png		\
 		albania-shield.png		\
 		aleut-shield.png		\
 		algeria-shield.png		\
@@ -1730,6 +1733,7 @@ shield_files =					\
 		ainu-shield-large.png			\
 		akwe-shield-large.png			\
 		aland-shield-large.png			\
+		alaska-shield-large.png			\
 		albania-shield-large.png		\
 		aleut-shield-large.png		\
 		algeria-shield-large.png		\
@@ -2303,6 +2307,7 @@ svg_files = 				\
 		ainu.svg		\
 		akwe.svg		\
 		aland.svg		\
+		alaska.svg		\
 		albania.svg		\
 		aleut.svg		\
 		algeria.svg		\
diff --git a/data/flags/alaska-large.png b/data/flags/alaska-large.png
new file mode 100644
index 0000000000000000000000000000000000000000..6bc3a9a0cc551e12c1fc31f269b98a56ca12c140
GIT binary patch
diff --git a/data/flags/alaska-shield-large.png b/data/flags/alaska-shield-large.png
new file mode 100644
index 0000000000000000000000000000000000000000..cbba1ba241e6eb918d01febb0dee8aa0e756a377
GIT binary patch
diff --git a/data/flags/alaska-shield.png b/data/flags/alaska-shield.png
new file mode 100644
index 0000000000000000000000000000000000000000..8a342612affa4d4e80658fce627d73e4dfedfed8
GIT binary patch
diff --git a/data/flags/alaska.png b/data/flags/alaska.png
new file mode 100644
index 0000000000000000000000000000000000000000..3f34488288e7970d2102b458d1451fca6549ad55
GIT binary patch
diff --git a/data/flags/alaska.svg b/data/flags/alaska.svg
new file mode 100644
index 0000000000..a32b0fc800
--- /dev/null
+++ b/data/flags/alaska.svg
@@ -0,0 +1 @@
+<svg width="1416" height="1000" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"><path fill="#0F204B" d="M0 0h1416v1000H0z"/><g transform="matrix(57.48978 0 0 57.48978 1157.996 187.49)" fill="#ffb612"><g id="b"><path id="a" transform="rotate(18 3.157 -.5)" d="M0 0v1h.5z"/><use transform="scale(-1 1)" xlink:href="#a"/></g><use transform="rotate(72)" xlink:href="#b"/><use transform="rotate(-72)" xlink:href="#b"/><use transform="rotate(144)" xlink:href="#b"/><use transform="rotate(216)" xlink:href="#b"/></g><g id="c" transform="matrix(34.27276 0 0 34.27276 228.995 399.273)" fill="#ffb612"><path transform="rotate(18 3.157 -.5)" d="M0 0v1h.5z"/><use transform="scale(-1 1)" xlink:href="#a"/><use transform="rotate(72)" xlink:href="#b"/><use transform="rotate(-72)" xlink:href="#b"/><use transform="rotate(144)" xlink:href="#b"/><use transform="rotate(216)" xlink:href="#b"/></g><use transform="translate(167 62)" xlink:href="#c"/><use transform="translate(250 151)" xlink:href="#c"/><use transform="translate(334 244)" xlink:href="#c"/><use transform="translate(584 333)" xlink:href="#c"/><use transform="translate(323 375)" xlink:href="#c"/><use transform="translate(511 437)" xlink:href="#c"/></svg>
\ No newline at end of file
diff --git a/data/misc/flags-large.spec b/data/misc/flags-large.spec
index ecc8609296..21dfd31c29 100644
--- a/data/misc/flags-large.spec
+++ b/data/misc/flags-large.spec
@@ -24,6 +24,7 @@ sprites =
 		"f.ainu", "flags/ainu-large"
 		"f.akwe", "flags/akwe-large"
 		"f.aland", "flags/aland-large"
+		"f.alaska", "flags/alaska-large"
 		"f.albania", "flags/albania-large"
 		"f.aleut", "flags/aleut-large"
 		"f.algeria", "flags/algeria-large"
diff --git a/data/misc/flags.spec b/data/misc/flags.spec
index 1284689c51..ab27dc1ae7 100644
--- a/data/misc/flags.spec
+++ b/data/misc/flags.spec
@@ -23,6 +23,7 @@ artists = "
    Ainu			Daniel Markstedt
    Akwe			Dan Cottrell and Daniel Markstedt
    Aland		J.M. Maalderink
+   Alaska               (Wikimedia Commons)
    Albania		TigerTjäder (Wikimedia Commons)
    Aleut		Daniel Markstedt
    Algeria 		Lauris Kaplinski
@@ -597,6 +598,7 @@ sprites =
 		"f.ainu", "flags/ainu"
 		"f.akwe", "flags/akwe"
 		"f.aland", "flags/aland"
+		"f.alaska", "flags/alaska"
 		"f.albania", "flags/albania"
 		"f.aleut", "flags/aleut"
 		"f.algeria", "flags/algeria"
diff --git a/data/misc/shields-large.spec b/data/misc/shields-large.spec
index ae89b15864..9305364291 100644
--- a/data/misc/shields-large.spec
+++ b/data/misc/shields-large.spec
@@ -24,6 +24,7 @@ sprites =
 		"f.shield.ainu", "flags/ainu-shield-large"
 		"f.shield.akwe", "flags/akwe-shield-large"
 		"f.shield.aland", "flags/aland-shield-large"
+		"f.shield.alaska", "flags/alaska-shield-large"
 		"f.shield.albania", "flags/albania-shield-large"
 		"f.shield.aleut", "flags/aleut-shield-large"
 		"f.shield.algeria", "flags/algeria-shield-large"
diff --git a/data/misc/shields.spec b/data/misc/shields.spec
index 2fb3f2e58b..ebe1938cff 100644
--- a/data/misc/shields.spec
+++ b/data/misc/shields.spec
@@ -23,6 +23,7 @@ sprites =
 		"f.shield.ainu", "flags/ainu-shield"
 		"f.shield.akwe", "flags/akwe-shield"
 		"f.shield.aland", "flags/aland-shield"
+		"f.shield.alaska", "flags/alaska-shield"
 		"f.shield.albania", "flags/albania-shield"
 		"f.shield.aleut", "flags/aleut-shield"
 		"f.shield.algeria", "flags/algeria-shield"
diff --git a/data/nation/Makefile.am b/data/nation/Makefile.am
index b15820d37f..2dc456a4a5 100644
--- a/data/nation/Makefile.am
+++ b/data/nation/Makefile.am
@@ -17,6 +17,7 @@ pkgdata_DATA = \
 		akwe.ruleset \
 		alandalus.ruleset \
 		alander.ruleset \
+		alaskan.ruleset \
 		albanian.ruleset \
 		aleut.ruleset \
 		algerian.ruleset \
diff --git a/data/nation/alaskan.ruleset b/data/nation/alaskan.ruleset
new file mode 100644
index 0000000000..325a692fb1
--- /dev/null
+++ b/data/nation/alaskan.ruleset
@@ -0,0 +1,113 @@
+[nation_alaskan]
+
+name   = _("Alaska")
+plural = _("?plural:Alaskans")
+groups = "American", "Modern"
+legend = _("Alaska is a state in the United States of America that was\
+ purchased from the Russian Empire in 1867, it became an organized\
+ territory on May 11th, 1912 and eventually gained statehood as the\
+ 49th state on January 3rd, 1959. The question of Alaskan\
+ independence became more relevant with the election of Wally\
+ Hickel in 1990.")
+
+leaders = {
+ "name",                  "sex"
+ "Jefferson C. Davis",    "Male"   ; First chief federal officers of the Department of Alaska
+ "Henry E. Nichols",      "Male"   ; 20th and last chief federal officers of the Department of Alaska
+ "John Henry Kinkead",    "Male"   ; First Governor of the District of Alaska
+ "Walter Eli Clark",      "Male"   ; Last Governor of the District of Alaska and first Governor of the Territory of Alaska
+ "Mike Stepovich",        "Male"   ; Last Governor of the Territory of Alaska
+ "William A. Egan",       "Male"   ; First governor of the State of Alaska
+ "Wally Hickel",          "Male"   ; 2nd governor of the State of Alaska, only governor to be a member of the Alaskan Independece party
+ "Mike Gravel",           "Male"   ; Senator from Alaska and presidental canidate
+ "Sarah Palin",           "Female" ; 9th governor of the State of Alaska and vice presidental canidate
+ "Mike Dunleavy",         "Male"   ; 12th and current governor of the state of Alaska
+}
+
+ruler_titles = {
+ "government",      "male_title",      "female_title"
+ "Despotism",       _("Sheriff %s"),   _("?female:Sheriff %s")
+ "Republic",        _("Governor %s"),  _("?female:Governor %s")
+ "Fundamentalism",  _("Reverend %s"),  _("?female:Reverend %s")
+}
+
+flag     = "alaska" ; Pulled from wikimedia commons
+flag_alt = "usa"
+style    = "European"
+
+init_techs = ""
+init_buildings = ""
+init_units = ""
+
+civilwar_nations = "aleut", "american", "canadian"
+
+cities =
+ "Juneau",
+ "Anchorage",
+ "Fairbanks",
+ "Wasilia",
+ "Sitka",
+ "Ketchikan",
+ "Kenai",
+ "Bethel",
+ "Palmer",
+ "Kodiak",
+ "Homer",
+ "Utqiaġvik",     ;Barrow
+ "Soldotna",
+ "Unalaska",
+ "Valdez",
+ "Nome",
+ "Kotzebue",
+ "Seward",
+ "Cordova",
+ "Dillingham",
+ "North Pole",
+ "Wrangell",
+ "Houston",
+ "Akutan",
+ "Hooper Bay",
+ "Craig",
+ "Chevak",
+ "Hoonah",
+ "Delta Junction",
+ "Savoonga",
+ "Point Hope",
+ "Emmonak",
+ "Togiak",
+ "Kwethluk",
+ "Selawik",
+ "Quinhagak",
+ "Unalakleet",
+ "King Cove",
+ "Alakanuk",
+ "Klawock",
+ "Noorvik",
+ "Toksook Bay",
+ "Gustavus",
+ "Kotlik",
+ "Gambell",
+ "Stebbins",
+ "Wainwright",
+ "Mountain Village",
+ "Pilot Station",
+ "Scammon Bay",
+ "St. Mary's",
+ "Nunapitchuk",
+ "Sand Point",
+ "Kachemak",
+ "Shishmaref",
+ "Buckland",
+ "Kake",
+ "New Stuyahok",
+ "Nuiqsut",
+ "Napaskiak",
+ "Aniak",
+ "Chefornak",
+ "Marshall",
+ "Manokotak",
+ "Thorne Bay",
+ "Galena",
+ "Akiak",
+ "St. Michael",
+ "Kiana"
diff --git a/data/nation/aleut.ruleset b/data/nation/aleut.ruleset
index fd5845af14..4c2891bf47 100644
--- a/data/nation/aleut.ruleset
+++ b/data/nation/aleut.ruleset
@@ -31,7 +31,7 @@ init_techs = ""
 init_buildings = ""
 init_units = ""
 
-civilwar_nations = "inuit", "nuu-chah-nulth", "cree"
+civilwar_nations = "inuit", "nuu-chah-nulth", "cree", "alaskan"
 
 cities =
  "Akutan",
diff --git a/meson.build b/meson.build
index 775f714744..858e3b67b8 100644
--- a/meson.build
+++ b/meson.build
@@ -1541,6 +1541,7 @@ nations = [
   'akwe',
   'alandalus',
   'alander',
+  'alaskan',
   'albanian',
   'aleut',
   'algerian',
@@ -2324,6 +2325,7 @@ flags = [
   'ainu',
   'akwe',
   'aland',
+  'alaska',
   'albania',
   'aleut',
   'algeria',
diff --git a/translations/nations/POTFILES.in b/translations/nations/POTFILES.in
index c1461b3feb..2ecf495306 100644
--- a/translations/nations/POTFILES.in
+++ b/translations/nations/POTFILES.in
@@ -12,6 +12,7 @@ data/nation/ainu.ruleset
 data/nation/akwe.ruleset
 data/nation/alandalus.ruleset
 data/nation/alander.ruleset
+data/nation/alaskan.ruleset
 data/nation/albanian.ruleset
 data/nation/aleut.ruleset
 data/nation/algerian.ruleset
-- 
2.43.0